Index: branches/presentation/src/ai/ai_team.cc
===================================================================
--- branches/presentation/src/ai/ai_team.cc	(revision 10729)
+++ branches/presentation/src/ai/ai_team.cc	(revision 10730)
@@ -55,6 +55,5 @@
 				Vector targetPos=target->getAbsCoor();
 				float distanceToPlayer=(targetPos-position).len();
-
-				int zNorm=(position.z>targetPos.z)?1:-1;
+// 				int zNorm=(position.z>targetPos.z)?1:-1;  // unused var
 
 				if(distanceToPlayer<attackDistance+60){	//### change wakeup distance here
Index: branches/presentation/src/lib/graphics/importer/static_model.cc
===================================================================
--- branches/presentation/src/lib/graphics/importer/static_model.cc	(revision 10729)
+++ branches/presentation/src/lib/graphics/importer/static_model.cc	(revision 10730)
@@ -101,5 +101,4 @@
 void StaticModel::extractMountPoints()
 {
-//   printf("extracting MP...");
   // go through all groups and check if they are mounts
   std::vector<StaticModelData::Group>::iterator groupIt = this->data->getGroups().begin();
@@ -114,6 +113,4 @@
     // check if the name has a "MP" prefix or else it won't work
     if( groupName.find("MP.", 0) == std::string::npos){
-//       groupIt++;
-//       printf("Found MP:  ");
       continue;
     }
@@ -128,6 +125,4 @@
       PRINTF(4)("the face count of %s is wrong, perhaps you missnamed this object or used the wrong mount point object (got %i faces)\n",
                 groupName.c_str(), (*groupIt)._faces.size());
-//       printf("wrong number of faces\n\n");
-//       groupIt++;
       continue;
     }
@@ -143,5 +138,4 @@
     }
 
-//     printf("confirmed  ");
 
     Vector center;
@@ -150,21 +144,16 @@
     Vector zAxis;
     // now process all points
-//     printf("entering loop: ");
     for( int i = 0; i < 3; i++)
     {
-//       printf("%i ", i);
       // convert the float vertices to vectors
       Vector a( this->data->getVertices()[triangle[i]._elements[0].vertexNumber * 3],
                 this->data->getVertices()[triangle[i]._elements[0].vertexNumber * 3 + 1],
                 this->data->getVertices()[triangle[i]._elements[0].vertexNumber * 3 + 2]);
-//       printf("a");
       Vector b( this->data->getVertices()[triangle[i]._elements[1].vertexNumber * 3],
                 this->data->getVertices()[triangle[i]._elements[1].vertexNumber * 3 + 1],
                 this->data->getVertices()[triangle[i]._elements[1].vertexNumber * 3 + 2]);
-//       printf("b");
       Vector c( this->data->getVertices()[triangle[i]._elements[2].vertexNumber * 3],
                 this->data->getVertices()[triangle[i]._elements[2].vertexNumber * 3 + 1],
                 this->data->getVertices()[triangle[i]._elements[2].vertexNumber * 3 + 2]);
-//       printf("c  ");
 
       Vector ab = a - b;
@@ -220,17 +209,8 @@
     }
 
-//     printf("adding MP\n");
-    // now add the mount point
+    printf("adding MP\n");
      this->addMountPoint( zAxis, yAxis, center, groupName);
 
-//     printf("removing item...");
-    // remove the group from the model list (mount points do not need to be drawn)
-//      std::vector<StaticModelData::Group>::iterator tmpIt =  groupIt;
-//      groupIt++;
-//     printf("   removing...");
-//      this->data->getGroups().erase(tmpIt);
-//     printf("   REMOVED\n");
   }
-//   printf("done\n");
 }
 
Index: branches/presentation/src/world_entities/space_ships/space_ship.cc
===================================================================
--- branches/presentation/src/world_entities/space_ships/space_ship.cc	(revision 10729)
+++ branches/presentation/src/world_entities/space_ships/space_ship.cc	(revision 10730)
@@ -463,5 +463,5 @@
       {
         int slot = ws->getWeaponSlot();
-//         int side = ws->getWeaponSide(); //FIXME / REMOVE: is not used// HACK needed for some weapons (left/right)
+//         int side = ws->getWeaponSide(); // HACK needed for some weapons (left/right)
         this->getWeaponManager().setSlotPosition(slot, (*it).second->getCenter());
         this->getWeaponManager().setSlotDirection(slot, ws->getRelDir());