Index: code/branches/cpp11_v2/src/modules/jump/Jump.cc
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/Jump.cc	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/Jump.cc	(revision 10733)
@@ -34,9 +34,5 @@
 #include "Jump.h"
 #include "core/CoreIncludes.h"
-#include "core/EventIncludes.h"
-#include "core/command/Executor.h"
-#include "core/config/ConfigValueIncludes.h"
-#include "gamestates/GSLevel.h"
-#include "chat/ChatManager.h"
+
 #include "JumpCenterpoint.h"
 #include "JumpPlatform.h"
@@ -56,5 +52,8 @@
 #include "JumpBoots.h"
 #include "JumpShield.h"
+
+#include "gamestates/GSLevel.h"
 #include "infos/PlayerInfo.h"
+#include "graphics/Camera.h"
 
 namespace orxonox
@@ -70,6 +69,4 @@
         camera = 0;
         setHUDTemplate("JumpHUD");
-
-        setConfigValues();
     }
 
@@ -1300,3 +1297,9 @@
         return figure_->dead_;
     }
+
+    void Jump::setCenterpoint(JumpCenterpoint* center)
+    {
+        center_ = center;
+    }
+
 }
Index: code/branches/cpp11_v2/src/modules/jump/Jump.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/Jump.h	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/Jump.h	(revision 10733)
@@ -31,9 +31,5 @@
 
 #include "jump/JumpPrereqs.h"
-#include "tools/Timer.h"
-#include "graphics/Camera.h"
 #include "gametypes/Deathmatch.h"
-#include "JumpCenterpoint.h"
-#include <list>
 
 namespace orxonox
@@ -51,6 +47,5 @@
             float getFuel() const;
             bool getDead(PlayerInfo* player) const;
-            void setCenterpoint(JumpCenterpoint* center)
-                { center_ = center; }
+            void setCenterpoint(JumpCenterpoint* center);
             PlayerInfo* getPlayer() const;
 
Index: code/branches/cpp11_v2/src/modules/jump/JumpBoots.cc
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpBoots.cc	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpBoots.cc	(revision 10733)
@@ -35,12 +35,6 @@
 
 #include "core/CoreIncludes.h"
-#include "core/GameMode.h"
-#include "graphics/Model.h"
-#include "gametypes/Gametype.h"
-
+#include "core/XMLPort.h"
 #include "JumpFigure.h"
-
-#include "sound/WorldSound.h"
-#include "core/XMLPort.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpBoots.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpBoots.h	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpBoots.h	(revision 10733)
@@ -30,8 +30,6 @@
 #define _JumpBoots_H__
 
-#include "jump/JumpPrereqs.h"
-#include "util/Math.h"
-#include "worldentities/MovableEntity.h"
-
+#include "JumpPrereqs.h"
+#include "JumpItem.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpCenterpoint.cc
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpCenterpoint.cc	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpCenterpoint.cc	(revision 10733)
@@ -33,4 +33,5 @@
 
 #include "JumpCenterpoint.h"
+
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
Index: code/branches/cpp11_v2/src/modules/jump/JumpCenterpoint.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpCenterpoint.h	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpCenterpoint.h	(revision 10733)
@@ -31,9 +31,4 @@
 
 #include "jump/JumpPrereqs.h"
-
-#include <string>
-
-#include <util/Math.h>
-
 #include "worldentities/StaticEntity.h"
 
Index: code/branches/cpp11_v2/src/modules/jump/JumpEnemy.cc
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpEnemy.cc	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpEnemy.cc	(revision 10733)
@@ -35,12 +35,6 @@
 
 #include "core/CoreIncludes.h"
-#include "core/GameMode.h"
-#include "graphics/Model.h"
-#include "gametypes/Gametype.h"
-
+#include "core/XMLPort.h"
 #include "JumpFigure.h"
-
-#include "sound/WorldSound.h"
-#include "core/XMLPort.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpEnemy.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpEnemy.h	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpEnemy.h	(revision 10733)
@@ -37,9 +37,5 @@
 
 #include "jump/JumpPrereqs.h"
-
-#include "util/Math.h"
-
 #include "worldentities/MovableEntity.h"
-
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpFigure.cc
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpFigure.cc	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpFigure.cc	(revision 10733)
@@ -36,4 +36,9 @@
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
+#include "graphics/Model.h"
+#include "JumpRocket.h"
+#include "JumpPropeller.h"
+#include "JumpBoots.h"
+#include "JumpShield.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpItem.cc
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpItem.cc	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpItem.cc	(revision 10733)
@@ -35,12 +35,6 @@
 
 #include "core/CoreIncludes.h"
-#include "core/GameMode.h"
-#include "graphics/Model.h"
-#include "gametypes/Gametype.h"
-
+#include "core/XMLPort.h"
 #include "JumpFigure.h"
-
-#include "sound/WorldSound.h"
-#include "core/XMLPort.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpItem.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpItem.h	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpItem.h	(revision 10733)
@@ -37,7 +37,4 @@
 
 #include "jump/JumpPrereqs.h"
-
-#include "util/Math.h"
-
 #include "worldentities/MovableEntity.h"
 
Index: code/branches/cpp11_v2/src/modules/jump/JumpPlatform.cc
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPlatform.cc	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPlatform.cc	(revision 10733)
@@ -36,11 +36,7 @@
 #include "core/CoreIncludes.h"
 #include "core/GameMode.h"
-#include "graphics/Model.h"
-#include "gametypes/Gametype.h"
-
+#include "core/XMLPort.h"
+#include "sound/WorldSound.h"
 #include "JumpFigure.h"
-
-#include "sound/WorldSound.h"
-#include "core/XMLPort.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpPlatform.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPlatform.h	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPlatform.h	(revision 10733)
@@ -36,6 +36,5 @@
 #define _JumpPlatform_H__
 
-#include "jump/JumpPrereqs.h"
-#include "util/Math.h"
+#include "JumpPrereqs.h"
 #include "worldentities/MovableEntity.h"
 
Index: code/branches/cpp11_v2/src/modules/jump/JumpPlatformDisappear.cc
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPlatformDisappear.cc	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPlatformDisappear.cc	(revision 10733)
@@ -35,12 +35,6 @@
 
 #include "core/CoreIncludes.h"
-#include "core/GameMode.h"
-
-#include "gametypes/Gametype.h"
-
+#include "core/XMLPort.h"
 #include "JumpFigure.h"
-
-#include "sound/WorldSound.h"
-#include "core/XMLPort.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpPlatformDisappear.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPlatformDisappear.h	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPlatformDisappear.h	(revision 10733)
@@ -36,7 +36,6 @@
 #define _JumpPlatformDisappear_H__
 
-#include "jump/JumpPrereqs.h"
-#include "util/Math.h"
-#include "worldentities/MovableEntity.h"
+#include "JumpPrereqs.h"
+#include "JumpPlatform.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpPlatformFake.cc
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPlatformFake.cc	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPlatformFake.cc	(revision 10733)
@@ -33,9 +33,6 @@
 
 #include "JumpPlatformFake.h"
+
 #include "core/CoreIncludes.h"
-#include "core/GameMode.h"
-#include "gametypes/Gametype.h"
-#include "JumpFigure.h"
-#include "sound/WorldSound.h"
 #include "core/XMLPort.h"
 
Index: code/branches/cpp11_v2/src/modules/jump/JumpPlatformFake.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPlatformFake.h	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPlatformFake.h	(revision 10733)
@@ -36,10 +36,6 @@
 #define _JumpPlatformFake_H__
 
-#include "jump/JumpPrereqs.h"
-
-#include "util/Math.h"
-
-#include "worldentities/MovableEntity.h"
-
+#include "JumpPrereqs.h"
+#include "JumpPlatform.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpPlatformHMove.cc
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPlatformHMove.cc	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPlatformHMove.cc	(revision 10733)
@@ -33,10 +33,8 @@
 
 #include "JumpPlatformHMove.h"
+
 #include "core/CoreIncludes.h"
-#include "core/GameMode.h"
-#include "gametypes/Gametype.h"
+#include "core/XMLPort.h"
 #include "JumpFigure.h"
-#include "sound/WorldSound.h"
-#include "core/XMLPort.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpPlatformHMove.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPlatformHMove.h	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPlatformHMove.h	(revision 10733)
@@ -30,10 +30,6 @@
 #define _JumpPlatformHMove_H__
 
-#include "jump/JumpPrereqs.h"
-
-#include "util/Math.h"
-
-#include "worldentities/MovableEntity.h"
-
+#include "JumpPrereqs.h"
+#include "JumpPlatform.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpPlatformStatic.cc
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPlatformStatic.cc	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPlatformStatic.cc	(revision 10733)
@@ -33,10 +33,8 @@
 
 #include "JumpPlatformStatic.h"
+
 #include "core/CoreIncludes.h"
-#include "core/GameMode.h"
-#include "gametypes/Gametype.h"
+#include "core/XMLPort.h"
 #include "JumpFigure.h"
-#include "sound/WorldSound.h"
-#include "core/XMLPort.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpPlatformStatic.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPlatformStatic.h	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPlatformStatic.h	(revision 10733)
@@ -30,10 +30,6 @@
 #define _JumpPlatformStatic_H__
 
-#include "jump/JumpPrereqs.h"
-
-#include "util/Math.h"
-
-#include "worldentities/MovableEntity.h"
-
+#include "JumpPrereqs.h"
+#include "JumpPlatform.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpPlatformTimer.cc
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPlatformTimer.cc	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPlatformTimer.cc	(revision 10733)
@@ -33,10 +33,9 @@
 
 #include "JumpPlatformTimer.h"
+
 #include "core/CoreIncludes.h"
-#include "core/GameMode.h"
-#include "gametypes/Gametype.h"
+#include "core/XMLPort.h"
+#include "graphics/ParticleSpawner.h"
 #include "JumpFigure.h"
-#include "sound/WorldSound.h"
-#include "core/XMLPort.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpPlatformTimer.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPlatformTimer.h	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPlatformTimer.h	(revision 10733)
@@ -36,11 +36,6 @@
 #define _JumpPlatformTimer_H__
 
-#include "jump/JumpPrereqs.h"
-
-#include "util/Math.h"
-
-#include "worldentities/MovableEntity.h"
-#include "graphics/ParticleSpawner.h"
-
+#include "JumpPrereqs.h"
+#include "JumpPlatform.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpPlatformVMove.cc
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPlatformVMove.cc	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPlatformVMove.cc	(revision 10733)
@@ -33,10 +33,8 @@
 
 #include "JumpPlatformVMove.h"
+
 #include "core/CoreIncludes.h"
-#include "core/GameMode.h"
-#include "gametypes/Gametype.h"
+#include "core/XMLPort.h"
 #include "JumpFigure.h"
-#include "sound/WorldSound.h"
-#include "core/XMLPort.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpPlatformVMove.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPlatformVMove.h	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPlatformVMove.h	(revision 10733)
@@ -30,7 +30,6 @@
 #define _JumpPlatformVMove_H__
 
-#include "jump/JumpPrereqs.h"
-#include "util/Math.h"
-#include "worldentities/MovableEntity.h"
+#include "JumpPrereqs.h"
+#include "JumpPlatform.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpProjectile.cc
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpProjectile.cc	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpProjectile.cc	(revision 10733)
@@ -33,11 +33,9 @@
 
 #include "JumpProjectile.h"
+
 #include "core/CoreIncludes.h"
-#include "core/GameMode.h"
-#include "graphics/Model.h"
-#include "gametypes/Gametype.h"
+#include "core/XMLPort.h"
 #include "JumpFigure.h"
-#include "sound/WorldSound.h"
-#include "core/XMLPort.h"
+#include "JumpEnemy.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpPropeller.cc
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPropeller.cc	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPropeller.cc	(revision 10733)
@@ -35,12 +35,6 @@
 
 #include "core/CoreIncludes.h"
-#include "core/GameMode.h"
-#include "graphics/Model.h"
-#include "gametypes/Gametype.h"
-
+#include "core/XMLPort.h"
 #include "JumpFigure.h"
-
-#include "sound/WorldSound.h"
-#include "core/XMLPort.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpPropeller.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpPropeller.h	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpPropeller.h	(revision 10733)
@@ -30,10 +30,6 @@
 #define _JumpPropeller_H__
 
-#include "jump/JumpPrereqs.h"
-
-#include "util/Math.h"
-
-#include "worldentities/MovableEntity.h"
-
+#include "JumpPrereqs.h"
+#include "JumpItem.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpRocket.cc
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpRocket.cc	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpRocket.cc	(revision 10733)
@@ -33,11 +33,8 @@
 
 #include "JumpRocket.h"
+
 #include "core/CoreIncludes.h"
-#include "core/GameMode.h"
-#include "graphics/Model.h"
-#include "gametypes/Gametype.h"
+#include "core/XMLPort.h"
 #include "JumpFigure.h"
-#include "sound/WorldSound.h"
-#include "core/XMLPort.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpRocket.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpRocket.h	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpRocket.h	(revision 10733)
@@ -30,7 +30,6 @@
 #define _JumpRocket_H__
 
-#include "jump/JumpPrereqs.h"
-#include "util/Math.h"
-#include "worldentities/MovableEntity.h"
+#include "JumpPrereqs.h"
+#include "JumpItem.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpScore.cc
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpScore.cc	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpScore.cc	(revision 10733)
@@ -33,4 +33,5 @@
 
 #include "JumpScore.h"
+
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
@@ -38,5 +39,4 @@
 #include "infos/PlayerInfo.h"
 #include "Jump.h"
-#include "sound/WorldSound.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpShield.cc
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpShield.cc	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpShield.cc	(revision 10733)
@@ -35,12 +35,6 @@
 
 #include "core/CoreIncludes.h"
-#include "core/GameMode.h"
-#include "graphics/Model.h"
-#include "gametypes/Gametype.h"
-
+#include "core/XMLPort.h"
 #include "JumpFigure.h"
-
-#include "sound/WorldSound.h"
-#include "core/XMLPort.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpShield.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpShield.h	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpShield.h	(revision 10733)
@@ -30,10 +30,6 @@
 #define _JumpShield_H__
 
-#include "jump/JumpPrereqs.h"
-
-#include "util/Math.h"
-
-#include "worldentities/MovableEntity.h"
-
+#include "JumpPrereqs.h"
+#include "JumpItem.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpSpring.cc
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpSpring.cc	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpSpring.cc	(revision 10733)
@@ -33,11 +33,8 @@
 
 #include "JumpSpring.h"
+
 #include "core/CoreIncludes.h"
-#include "core/GameMode.h"
-#include "graphics/Model.h"
-#include "gametypes/Gametype.h"
+#include "core/XMLPort.h"
 #include "JumpFigure.h"
-#include "sound/WorldSound.h"
-#include "core/XMLPort.h"
 
 namespace orxonox
Index: code/branches/cpp11_v2/src/modules/jump/JumpSpring.h
===================================================================
--- code/branches/cpp11_v2/src/modules/jump/JumpSpring.h	(revision 10732)
+++ code/branches/cpp11_v2/src/modules/jump/JumpSpring.h	(revision 10733)
@@ -30,10 +30,6 @@
 #define _JumpSpring_H__
 
-#include "jump/JumpPrereqs.h"
-
-#include "util/Math.h"
-
-#include "worldentities/MovableEntity.h"
-
+#include "JumpPrereqs.h"
+#include "JumpItem.h"
 
 namespace orxonox