Index: branches/presentation/src/world_entities/projectiles/hbolt.cc
===================================================================
--- branches/presentation/src/world_entities/projectiles/hbolt.cc	(revision 10736)
+++ branches/presentation/src/world_entities/projectiles/hbolt.cc	(revision 10737)
@@ -20,4 +20,6 @@
 #include "state.h"
 #include "model.h"
+
+#include "world_entities/npcs/actionbox_enemy.h"
 #include "world_entities/npcs/npc.h"
 
@@ -125,5 +127,5 @@
 {
   printf("Collision with HBolt\n");
-  if (this->hitEntity != entity && entity->isA(NPC::staticClassID()) || entity == this->target)
+  if (this->hitEntity != entity/* && entity->isA(NPC::staticClassID())*/ && entity->isA(ActionboxEnemy::staticClassID()) || entity == this->target)
     this->destroy( entity );
   this->hitEntity = entity;
@@ -148,5 +150,5 @@
   this->angle += HBolt::rotationSpeed * dt;
 
-  for( ObjectList<NPC>::const_iterator eIterator = NPC::objectList().begin(); eIterator !=NPC::objectList().end(); eIterator++)
+  for( ObjectList<ActionboxEnemy>::const_iterator eIterator = ActionboxEnemy::objectList().begin(); eIterator !=ActionboxEnemy::objectList().end(); eIterator++)
   {
     if( ((*eIterator)->getOMListNumber() != (this->origList -1))  && ((*eIterator)->getAbsCoor() - this->getAbsCoor()).len() <= 8)
Index: branches/presentation/src/world_entities/projectiles/hbolt.h
===================================================================
--- branches/presentation/src/world_entities/projectiles/hbolt.h	(revision 10736)
+++ branches/presentation/src/world_entities/projectiles/hbolt.h	(revision 10737)
@@ -9,4 +9,5 @@
 #include "projectile.h"
 #include "effects/billboard.h"
+
 
 class Vector;
Index: branches/presentation/src/world_entities/projectiles/nadion_blast.cc
===================================================================
--- branches/presentation/src/world_entities/projectiles/nadion_blast.cc	(revision 10736)
+++ branches/presentation/src/world_entities/projectiles/nadion_blast.cc	(revision 10737)
@@ -23,4 +23,5 @@
 #include "model.h"
 
+#include "world_entities/npcs/actionbox_enemy.h"
 #include "world_entities/npcs/npc.h"
 
@@ -149,18 +150,18 @@
 }
 
-/*
-void NadionBlast::hit (float damage, WorldEntity* entity )
-{
-
-  if (this->hitEntity != entity)
-    this->destroy( entity );
-  this->hitEntity = entity;
- // dynamic_cast<SpaceShip*>(entity)->damage(this->getPhysDamage(),this->getElecDamage());
-  //this->destroy(this);
-  this->deactivate();
-
-  return;
-
-}*/
+
+// void NadionBlast::hit (float damage, WorldEntity* entity )
+// {
+// 
+//   if (this->hitEntity != entity)
+//     this->destroy( entity );
+//   this->hitEntity = entity;
+//  // dynamic_cast<SpaceShip*>(entity)->damage(this->getPhysDamage(),this->getElecDamage());
+//   //this->destroy(this);
+//   this->deactivate();
+// 
+//   return;
+// 
+// }
 
 /**
@@ -180,5 +181,5 @@
 //   this->trail->tick(dt);
 
-  for( ObjectList<NPC>::const_iterator eIterator = NPC::objectList().begin(); eIterator !=NPC::objectList().end(); eIterator++)
+  for( ObjectList<ActionboxEnemy>::const_iterator eIterator = ActionboxEnemy::objectList().begin(); eIterator !=ActionboxEnemy::objectList().end(); eIterator++)
   {
     if( ((*eIterator)->getOMListNumber() != (this->origList -1))  && ((*eIterator)->getAbsCoor() - this->getAbsCoor()).len() <= 8)
@@ -215,5 +216,5 @@
 //   glRotatef(this->angle, 1.0f, 0.0f, 0.0f); //spinning missile 
 // HACK, need to be removed, once the AbsDir is correct, replace with the one above
-  glRotatef(this->angle, this->flightDirection.x, this->flightDirection.y, this->flightDirection.z); 
+//   glRotatef(this->angle, this->flightDirection.x, this->flightDirection.y, this->flightDirection.z); 
   this->getAbsDir().matrix (matrix);
   glMultMatrixf((float*)matrix);
Index: branches/presentation/src/world_entities/projectiles/plasma_pulse.cc
===================================================================
--- branches/presentation/src/world_entities/projectiles/plasma_pulse.cc	(revision 10736)
+++ branches/presentation/src/world_entities/projectiles/plasma_pulse.cc	(revision 10737)
@@ -21,4 +21,5 @@
 
 #include "state.h"
+#include "world_entities/npcs/actionbox_enemy.h"
 
 #include <cassert>
@@ -112,5 +113,5 @@
   this->grid->tick(dt);
 
-  for( ObjectList<Playable>::const_iterator eIterator = Playable::objectList().begin(); eIterator !=Playable::objectList().end(); eIterator++)
+  for( ObjectList<ActionboxEnemy>::const_iterator eIterator = ActionboxEnemy::objectList().begin(); eIterator !=ActionboxEnemy::objectList().end(); eIterator++)
   {
     if( ((*eIterator)->getOMListNumber() != (this->origList -1))  && ((*eIterator)->getAbsCoor() - this->getAbsCoor()).len() <= 3)
Index: branches/presentation/src/world_entities/projectiles/test_bullet.cc
===================================================================
--- branches/presentation/src/world_entities/projectiles/test_bullet.cc	(revision 10736)
+++ branches/presentation/src/world_entities/projectiles/test_bullet.cc	(revision 10737)
@@ -136,11 +136,11 @@
   this->lifeCycle += time/this->lifeSpan;
   if( this->lifeCycle >= 1.0)
-    {
-      PRINTF(5)("FINALIZE==========================\n");
-      PRINTF(5)("current life cycle is: %f\n", this->lifeCycle);
-      PRINTF(5)("FINALIZE===========================\n");
+  {
+    PRINTF(5)("FINALIZE==========================\n");
+    PRINTF(5)("current life cycle is: %f\n", this->lifeCycle);
+    PRINTF(5)("FINALIZE===========================\n");
 
-      this->deactivate();
-    }
+    this->deactivate();
+  }
 }
 
Index: branches/presentation/src/world_entities/weapons/nadion_laser.cc
===================================================================
--- branches/presentation/src/world_entities/weapons/nadion_laser.cc	(revision 10736)
+++ branches/presentation/src/world_entities/weapons/nadion_laser.cc	(revision 10737)
@@ -155,6 +155,7 @@
 //   pj->setAbsDir(Quaternion(this->getDefaultTarget()->getAbsCoor() - this->getAbsCoor(), Vector(0,0,0)));
 //   pj->setAbsDir(Quaternion(tmp.getNormalized(), this->getParent()->getAbsDir().apply(Vector(0,1,0))));
-  pj->setAbsDir(Quaternion(dir, up.getNormalized()));
-  
+//   pj->setAbsDir(Quaternion(dir, up.getNormalized()));
+  pj->setAbsDir(Quaternion(dir, Vector(1,0,0)));
+
   pj->setAbsDir(this->getAbsDir());
   pj->activate();
Index: branches/presentation/src/world_entities/world_entity.h
===================================================================
--- branches/presentation/src/world_entities/world_entity.h	(revision 10736)
+++ branches/presentation/src/world_entities/world_entity.h	(revision 10737)
@@ -226,5 +226,4 @@
   void setHealthRegen(float regen) { this->healthRegen = regen; };
   void createImplantWidget();
-    //  CharacterAttributes*    charAttr;         //!< the character attributes of a world_entity
 
   void setShield(float shield) { this->shield = shield; };
@@ -238,5 +237,5 @@
   void setElectronicTH(float th) { this->electronicTH = th; };
   void setElectronicRegen(float regen) { this->electronicRegen = regen; };
-  
+
   void setDamageable( bool damageable ){ this->damageable = damageable; }
   bool getDamageable(){ return this->damageable; }
@@ -270,8 +269,8 @@
   bool                    forwardDamageToParent;  //!< if true, damage taken will be forwardet to parent
   float                   healthMax;              //!< The Maximal energy this entity can take. 
-  float						implantEnergy;		//!< energy of implants
-  float                   healthRegen;        //!< Regeneration Rate of Health, mesured in units per second
+  float                   implantEnergy;          //!< energy of implants
+  float                   healthRegen;            //!< Regeneration Rate of Health, mesured in units per second
   OrxGui::GLGuiEnergyWidgetVertical* healthWidget;    //!< The Slider (if wanted).
-  OrxGui::GLGuiEnergyWidgetVertical* implantWidget; 
+  OrxGui::GLGuiEnergyWidgetVertical* implantWidget;
 
   float       shield;             //!< current shield
@@ -324,5 +323,5 @@
   float                   healthMax_write;
   int                     healthMax_handle;
-  
+
 
 