Index: /branches/presentation/src/world_entities/projectiles/acid_splash.cc
===================================================================
--- /branches/presentation/src/world_entities/projectiles/acid_splash.cc	(revision 10739)
+++ /branches/presentation/src/world_entities/projectiles/acid_splash.cc	(revision 10740)
@@ -24,4 +24,6 @@
 #include <cassert>
 #include "debug.h"
+
+#include "obb_tree.h"
 
 #include "effects/wobblegrid.h"
@@ -69,4 +71,8 @@
 
   this->grid->toList(OM_ENVIRON); 
+  
+  this->obbTree = new OBBTree();
+  this->obbTree->createBox(Vector(0.0f, 0.0f, 0.0f), Vector(1.0f, 1.0f, 1.0f));
+  this->setOBBTree(this->obbTree);
 }
 
@@ -125,14 +131,4 @@
 
   this->grid->tick(dt);
-
-  for( ObjectList<Playable>::const_iterator eIterator = Playable::objectList().begin(); eIterator !=Playable::objectList().end(); eIterator++)
-  {
-    if( ((*eIterator)->getOMListNumber() != (this->origList -1))  && ((*eIterator)->getAbsCoor() - this->getAbsCoor()).len() <= 8)
-    {
-      (*eIterator)->hit (this->getDamage(),this);
-      this->deactivate();
-    }
-  }
-
 }
 
Index: /branches/presentation/src/world_entities/projectiles/acid_splash.h
===================================================================
--- /branches/presentation/src/world_entities/projectiles/acid_splash.h	(revision 10739)
+++ /branches/presentation/src/world_entities/projectiles/acid_splash.h	(revision 10740)
@@ -41,4 +41,5 @@
 
     WorldEntity* hitEntity; // FIXME TEMPORARY
+    OBBTree*                    obbTree;
 };
 
Index: /branches/presentation/src/world_entities/projectiles/hbolt.cc
===================================================================
--- /branches/presentation/src/world_entities/projectiles/hbolt.cc	(revision 10739)
+++ /branches/presentation/src/world_entities/projectiles/hbolt.cc	(revision 10740)
@@ -29,4 +29,6 @@
 #include <cassert>
 #include "debug.h"
+
+#include "obb_tree.h"
 
 // #include "effects/billboard.h"
@@ -63,4 +65,8 @@
   this->halo->setTexture("hbolt_halo2.png");
   this->halo->setVisibility(false);
+  
+  this->obbTree = new OBBTree();
+  this->obbTree->createBox(Vector(0.0f, 0.0f, 0.0f), Vector(1.0f, 1.0f, 1.0f));
+  this->setOBBTree(this->obbTree);
 
 }
@@ -149,14 +155,4 @@
 
   this->angle += HBolt::rotationSpeed * dt;
-
-  for( ObjectList<ActionboxEnemy>::const_iterator eIterator = ActionboxEnemy::objectList().begin(); eIterator !=ActionboxEnemy::objectList().end(); eIterator++)
-  {
-    if( ((*eIterator)->getOMListNumber() != (this->origList -1))  && ((*eIterator)->getAbsCoor() - this->getAbsCoor()).len() <= 8)
-    {
-      (*eIterator)->destroy(this); //hit (this->getDamage(),this);
-      this->deactivate();
-  PRINTF(0)("HBolt destroyed\n");
-    }
-  }
 }
 
Index: /branches/presentation/src/world_entities/projectiles/hbolt.h
===================================================================
--- /branches/presentation/src/world_entities/projectiles/hbolt.h	(revision 10739)
+++ /branches/presentation/src/world_entities/projectiles/hbolt.h	(revision 10740)
@@ -48,4 +48,5 @@
 
     WorldEntity* hitEntity; // FIXME TEMPORARY
+    OBBTree*                    obbTree;
 };
 
Index: /branches/presentation/src/world_entities/projectiles/lbolt.cc
===================================================================
--- /branches/presentation/src/world_entities/projectiles/lbolt.cc	(revision 10739)
+++ /branches/presentation/src/world_entities/projectiles/lbolt.cc	(revision 10740)
@@ -31,4 +31,6 @@
 #include <cassert>
 #include "debug.h"
+
+#include "obb_tree.h"
 
 #include "space_ships/space_ship.h"
@@ -67,4 +69,8 @@
   this->halo->setPulse();
 
+    
+  this->obbTree = new OBBTree();
+  this->obbTree->createBox(Vector(0.0f, 0.0f, 0.0f), Vector(1.0f, 1.0f, 1.0f));
+  this->setOBBTree(this->obbTree);
 }
 
@@ -151,14 +157,4 @@
   if(angle > 360)
     angle -= 360;
-
-  for( ObjectList<NPC>::const_iterator eIterator = NPC::objectList().begin(); eIterator !=NPC::objectList().end(); eIterator++)
-  {
-    if( ((*eIterator)->getOMListNumber() != (this->origList -1))  && ((*eIterator)->getAbsCoor() - this->getAbsCoor()).len() <= 8)
-    {
-      (*eIterator)->destroy(this); //hit (this->getDamage(),this);
-      this->deactivate();
-  PRINTF(0)("LBolt destroyed\n");
-    }
-  }
 }
 
Index: /branches/presentation/src/world_entities/projectiles/lbolt.h
===================================================================
--- /branches/presentation/src/world_entities/projectiles/lbolt.h	(revision 10739)
+++ /branches/presentation/src/world_entities/projectiles/lbolt.h	(revision 10740)
@@ -48,4 +48,5 @@
 
     WorldEntity* hitEntity; // FIXME TEMPORARY
+    OBBTree*                    obbTree;
 };
 
Index: /branches/presentation/src/world_entities/projectiles/mbolt.cc
===================================================================
--- /branches/presentation/src/world_entities/projectiles/mbolt.cc	(revision 10739)
+++ /branches/presentation/src/world_entities/projectiles/mbolt.cc	(revision 10740)
@@ -36,4 +36,6 @@
 
 #include "effects/trail.h"
+
+#include "obb_tree.h"
 
 
@@ -84,4 +86,8 @@
 //   this->trail->setAbsCoor(this->getAbsCoor() - Vector(.7,0,0));
   this->trail->setAbsCoor(this->getAbsCoor() - this->getVelocity().getNormalized() * .7);
+  
+  this->obbTree = new OBBTree();
+  this->obbTree->createBox(Vector(0.0f, 0.0f, 0.0f), Vector(1.0f, 1.0f, 1.0f));
+  this->setOBBTree(this->obbTree);
 
 }
@@ -178,14 +184,4 @@
   this->angle += MBolt::rotationSpeed * dt;
   this->trail->tick(dt);
-
-  for( ObjectList<NPC>::const_iterator eIterator = NPC::objectList().begin(); eIterator !=NPC::objectList().end(); eIterator++)
-  {
-    if( ((*eIterator)->getOMListNumber() != (this->origList -1))  && ((*eIterator)->getAbsCoor() - this->getAbsCoor()).len() <= 8)
-    {
-      (*eIterator)->destroy(this); //hit (this->getDamage(),this);
-      this->deactivate();
-      PRINTF(0)("MBolt destroyed\n");
-    }
-  }
 }
 
Index: /branches/presentation/src/world_entities/projectiles/mbolt.h
===================================================================
--- /branches/presentation/src/world_entities/projectiles/mbolt.h	(revision 10739)
+++ /branches/presentation/src/world_entities/projectiles/mbolt.h	(revision 10740)
@@ -50,4 +50,5 @@
 
     WorldEntity* hitEntity; // FIXME TEMPORARY
+    OBBTree*                    obbTree;
 };
 
Index: /branches/presentation/src/world_entities/projectiles/nadion_blast.cc
===================================================================
--- /branches/presentation/src/world_entities/projectiles/nadion_blast.cc	(revision 10739)
+++ /branches/presentation/src/world_entities/projectiles/nadion_blast.cc	(revision 10740)
@@ -180,14 +180,4 @@
   this->angle += NadionBlast::rotationSpeed * dt;
 //   this->trail->tick(dt);
-
-  for( ObjectList<ActionboxEnemy>::const_iterator eIterator = ActionboxEnemy::objectList().begin(); eIterator !=ActionboxEnemy::objectList().end(); eIterator++)
-  {
-    if( ((*eIterator)->getOMListNumber() != (this->origList -1))  && ((*eIterator)->getAbsCoor() - this->getAbsCoor()).len() <= 8)
-    {
-      (*eIterator)->destroy(this); //hit (this->getDamage(),this);
-      this->deactivate();
-      PRINTF(0)("NadionBlast destroyed\n");
-    }
-  }
 }
 
Index: /branches/presentation/src/world_entities/projectiles/plasma_pulse.cc
===================================================================
--- /branches/presentation/src/world_entities/projectiles/plasma_pulse.cc	(revision 10739)
+++ /branches/presentation/src/world_entities/projectiles/plasma_pulse.cc	(revision 10740)
@@ -25,4 +25,6 @@
 #include <cassert>
 #include "debug.h"
+
+#include "obb_tree.h"
 
 
@@ -59,4 +61,8 @@
   this->blink->loadBlinkSequence( "66678998766" );
   this->blink->toList(OM_ENVIRON);*/
+  
+  this->obbTree = new OBBTree();
+  this->obbTree->createBox(Vector(0.0f, 0.0f, 0.0f), Vector(1.0f, 1.0f, 1.0f));
+  this->setOBBTree(this->obbTree);
 }
 
@@ -112,14 +118,4 @@
 
   this->grid->tick(dt);
-
-  for( ObjectList<ActionboxEnemy>::const_iterator eIterator = ActionboxEnemy::objectList().begin(); eIterator !=ActionboxEnemy::objectList().end(); eIterator++)
-  {
-    if( ((*eIterator)->getOMListNumber() != (this->origList -1))  && ((*eIterator)->getAbsCoor() - this->getAbsCoor()).len() <= 3)
-    {
-      (*eIterator)->hit (this->getDamage(),this);
-      this->deactivate();
-    }
-  }
-
 }
 
Index: /branches/presentation/src/world_entities/projectiles/plasma_pulse.h
===================================================================
--- /branches/presentation/src/world_entities/projectiles/plasma_pulse.h	(revision 10739)
+++ /branches/presentation/src/world_entities/projectiles/plasma_pulse.h	(revision 10740)
@@ -34,4 +34,5 @@
     static FastFactory*               fastFactory;
     Billboard*                        grid;
+    OBBTree*                    obbTree;
 //     Blink*                            blink;
 };
Index: /branches/presentation/src/world_entities/space_ships/space_ship.cc
===================================================================
--- /branches/presentation/src/world_entities/space_ships/space_ship.cc	(revision 10739)
+++ /branches/presentation/src/world_entities/space_ships/space_ship.cc	(revision 10740)
@@ -178,5 +178,5 @@
 
 
- /* this->weaponMan.addWeaponToSlot(0, 0, "RFCannon");
+  this->weaponMan.addWeaponToSlot(0, 0, "RFCannon");
   this->weaponMan.addWeaponToSlot(0, 1, "RFCannon");
   this->weaponMan.addWeaponToSlot(0, 2, "RFCannon");
@@ -185,15 +185,15 @@
   this->weaponMan.addWeaponToSlot(1, 1, "RFCannon");
   this->weaponMan.addWeaponToSlot(1, 2, "RFCannon");
-  this->weaponMan.addWeaponToSlot(1, 3, "RFCannon");*/
+  this->weaponMan.addWeaponToSlot(1, 3, "RFCannon");
 
 /*  this->weaponMan.addWeaponToSlot(0, 4, "NadionLaser");
   this->weaponMan.addWeaponToSlot(0, 5, "NadionLaser");
   this->weaponMan.addWeaponToSlot(2, 4, "NadionLaser");
-  this->weaponMan.addWeaponToSlot(2, 5, "NadionLaser");*/
+  this->weaponMan.addWeaponToSlot(2, 5, "NadionLaser");
 
   this->weaponMan.addWeaponToSlot(0, 6, "Disruptor");
   this->weaponMan.addWeaponToSlot(0, 7, "Disruptor");
   this->weaponMan.addWeaponToSlot(3, 6, "Disruptor");
-  this->weaponMan.addWeaponToSlot(3, 7, "Disruptor");
+  this->weaponMan.addWeaponToSlot(3, 7, "Disruptor");*/
 
 