Index: /branches/presentation/src/util/hud.cc
===================================================================
--- /branches/presentation/src/util/hud.cc	(revision 10740)
+++ /branches/presentation/src/util/hud.cc	(revision 10741)
@@ -72,4 +72,6 @@
   delete this->inputLine;
   delete this->notifier;
+  delete this->leftHit;
+  delete this->rightHit;
 
   delete this->_radar;
@@ -104,6 +106,5 @@
 	notifier->setAbsCoor2D(100,100);
 	
-	this->barSocket = new OrxGui::GLGuiImage();
-	this->barSocket->setParent2D(this->bottomRect);
+
 	
 	this->_radar = new OrxGui::GLGuiRadar();
@@ -115,22 +116,27 @@
 	if (this->playmode == FirstPerson)
 	{
-		this->topHit = new OrxGui::GLGuiImage();
+		/*this->topHit = new OrxGui::GLGuiImage();
 		this->topHit->loadImageFromFile("textures/gui/gui_hitbar.png");
 		this->topHit->setParent2D(this->middleRect);
-		this->topHit->setRelDir2D(-1.5708);
+		this->topHit->setAbsDir2D(-1.5708);
 		
 		this->bottomHit = new OrxGui::GLGuiImage();
 		this->bottomHit->loadImageFromFile("textures/gui/gui_hitbar.png");
 		this->bottomHit->setParent2D(this->middleRect);
-		this->bottomHit->setRelDir2D(1.5708);
+		this->bottomHit->setAbsDir2D(1.5708);*/
+
+		this->barSocket = new OrxGui::GLGuiImage();
+		this->barSocket->loadImageFromFile("textures/gui/gui_barSocket.png");
+		this->barSocket->setParent2D(this->bottomRect);
 		
 		this->leftHit = new OrxGui::GLGuiImage();
 		this->leftHit->loadImageFromFile("textures/gui/gui_hitbar.png");
 		this->leftHit->setParent2D(this->middleRect);
+		this->leftHit->shiftDir2D(0.5);
 		
 		this->rightHit = new OrxGui::GLGuiImage();
 		this->rightHit->loadImageFromFile("textures/gui/gui_hitbar.png");
 		this->rightHit->setParent2D(this->middleRect);
-		this->rightHit->setRelDir2D(3.1416);
+		
 		
 		this->leftRect->setParent2D(this);
@@ -388,5 +394,8 @@
       {
         //PRINTF(0)("WEAPON %s::%s in Slots\n", weapon->getClassCName(), weapon->getName());
-        weapon->getEnergyWidget()->setParent2D(this->rightRect);
+        if (this->playmode != FirstPerson)
+		weapon->getEnergyWidget()->setParent2D(this->rightRect);
+	else
+		weapon->getEnergyWidget()->setParent2D(this->bottomRect);
         weapon->getEnergyWidget()->show();
         weapon->getEnergyWidget()->setBackgroundColor(Color(.8,.2,.11, 0.1));
@@ -476,19 +485,23 @@
 	
 	this->middleRect->setParent2D(this);
-	//this->middleRect->setWidgetSize(float(this->resY)/2, float(this->resY)/2);
-	this->middleRect->setAbsCoor2D(/*float(this->resX - this->resY/2)/2, float(this->resY)/4*/float(this->resX/2), float(this->resY/2));
-	
-	this->bottomHit->setRelCoor2D(0, this->resY/4);
-	this->bottomHit->setWidgetSize(this->resX/10, this->resX/2);
+	this->middleRect->setWidgetSize(float(this->resY)/2, float(this->resY)/2);
+	this->middleRect->setAbsCoor2D(float(this->resX)/4, float(this->resY)/4/*float(this->resX/2), float(this->resY/2)*/);
+	
+	/*this->bottomHit->setRelCoor2D(0, this->resY/4);
+	this->bottomHit->setWidgetSize(this->resX/8, this->resX/3);
 	this->bottomHit->show();
 	this->topHit->setRelCoor2D(0, -this->resY/4);
-	this->topHit->setWidgetSize(this->resX/10, this->resX/2);
-	this->topHit->show();
-	this->leftHit->setRelCoor2D(-this->resX/4, 0);
-	this->leftHit->setWidgetSize(this->resX/10, this->resX/2);
+	this->topHit->setWidgetSize(this->resX/8, this->resX/3);
+	this->topHit->show();*/
+	this->leftHit->setRelCoor2D(0, 0);
+	this->leftHit->setWidgetSize(this->resX/9, this->resX/3);
 	this->leftHit->show();
-	this->rightHit->setRelCoor2D(this->resX/4, 0);
-	this->rightHit->setWidgetSize(this->resX/10, this->resX/2);
-	this->rightHit->show();
+	this->rightHit->setRelCoor2D(this->resX/3, 0);
+	this->rightHit->setWidgetSize(this->resX/9, this->resX/3);
+	this->rightHit->hide();
+
+	this->barSocket->setWidgetSize(overlayWidth, overlayWidth);
+	this->barSocket->setRelCoor2D(this->resX - overlayWidth, 0);
+	this->barSocket->hide();
 
 	//this->middleRect->show();
Index: /branches/presentation/src/util/hud.h
===================================================================
--- /branches/presentation/src/util/hud.h	(revision 10740)
+++ /branches/presentation/src/util/hud.h	(revision 10741)
@@ -119,7 +119,7 @@
   OrxGui::GLGuiWidget*		bottomRect;
   OrxGui::GLGuiWidget*		middleRect;
-  OrxGui::GLGuiWidget*		barSocket;
-  OrxGui::GLGuiImage*		topHit;
-  OrxGui::GLGuiImage*		bottomHit;
+  OrxGui::GLGuiImage*		barSocket;
+  //OrxGui::GLGuiImage*		topHit;
+  //OrxGui::GLGuiImage*		bottomHit;
   OrxGui::GLGuiImage*		leftHit;
   OrxGui::GLGuiImage*		rightHit;
Index: /branches/presentation/src/world_entities/creatures/fps_player.cc
===================================================================
--- /branches/presentation/src/world_entities/creatures/fps_player.cc	(revision 10740)
+++ /branches/presentation/src/world_entities/creatures/fps_player.cc	(revision 10741)
@@ -151,4 +151,5 @@
   this->cameraNode->addNodeFlags(PNODE_PROHIBIT_CHILD_DELETE);
 
+  this->getWeaponManager().setRotationSpeed(0);
   this->getWeaponManager().getFixedTarget()->setParent(this->cameraNode);
   this->getWeaponManager().getFixedTarget()->setParentMode(PNODE_ALL);