Index: /branches/presentation/src/world_entities/projectiles/plasma_pulse.cc
===================================================================
--- /branches/presentation/src/world_entities/projectiles/plasma_pulse.cc	(revision 10741)
+++ /branches/presentation/src/world_entities/projectiles/plasma_pulse.cc	(revision 10742)
@@ -51,5 +51,5 @@
   this->grid->setPulse();
   this->grid->setTexture( "textures/plasma.png");
-  //this->grid->toList(OM_ENVIRON);
+  this->grid->toList(OM_ENVIRON);
 /*
   this->blink = new Blink();
@@ -82,5 +82,5 @@
 {
   this->origList = this->getOMListNumber();
-  //this->toList(OM_ENVIRON);
+  this->toList(OM_ENVIRON);
   this->grid->setVisibility(true);
 //   this->blink->setVisibility(true);
Index: /branches/presentation/src/world_entities/space_ships/space_ship.cc
===================================================================
--- /branches/presentation/src/world_entities/space_ships/space_ship.cc	(revision 10741)
+++ /branches/presentation/src/world_entities/space_ships/space_ship.cc	(revision 10742)
@@ -187,5 +187,5 @@
   this->weaponMan.addWeaponToSlot(1, 3, "RFCannon");
 
-/*  this->weaponMan.addWeaponToSlot(0, 4, "NadionLaser");
+  this->weaponMan.addWeaponToSlot(0, 4, "NadionLaser");
   this->weaponMan.addWeaponToSlot(0, 5, "NadionLaser");
   this->weaponMan.addWeaponToSlot(2, 4, "NadionLaser");
@@ -195,5 +195,5 @@
   this->weaponMan.addWeaponToSlot(0, 7, "Disruptor");
   this->weaponMan.addWeaponToSlot(3, 6, "Disruptor");
-  this->weaponMan.addWeaponToSlot(3, 7, "Disruptor");*/
+  this->weaponMan.addWeaponToSlot(3, 7, "Disruptor");
 
 
@@ -333,6 +333,6 @@
   LoadParam(root, "loadShield", this, WorldEntity, loadShield)
   .describe("set shield parameters: current strenght , max strenght, threshhold value (0..1), regeneration rate");
-  LoadParam(root, "loadHealth", this, WorldEntity, loadHealth)
-  .describe("set armor/health parameters: current strenght , max strenght");
+//   LoadParam(root, "loadHealth", this, WorldEntity, loadHealth)
+//   .describe("set armor/health parameters: current strenght , max strenght");
   LoadParam(root, "loadElectronic", this, WorldEntity, loadElectronic)
   .describe("set electronics parameters: current strenght , max strenght, threshhold value (0..1), regeneration rate");
@@ -346,18 +346,4 @@
   LoadParam(root, "mouseSenitivity", this, SpaceShip, setMouseSensitivity);
 
-/*
-  LOAD_PARAM_START_CYCLE(root, element);
-  {
-    LoadParamXML_CYCLE(element, "weaponMan", this->weaponMan, WeaponManager, loadWeapons)
-    .describe("loads Weapons");
-  }
-  LOAD_PARAM_END_CYCLE(element);
-
-  LOAD_PARAM_START_CYCLE(root, element);
-  {
-    LoadParamXML_CYCLE(element, "secWeaponMan", this->secWeaponMan, WeaponManager, loadWeapons)
-    .describe("loads Weapons");
-  }
-  LOAD_PARAM_END_CYCLE(element);*/
 }
 
@@ -427,24 +413,4 @@
   WorldEntity::draw();
 
-//   glMatrixMode(GL_MODELVIEW);
-//   glPushMatrix();
-
-//   float matrix[4][4];
-//   glTranslatef (this->getAbsCoor ().x-1, this->getAbsCoor ().y-.2, this->getAbsCoor ().z);
-//   this->getAbsDir().matrix (matrix);
-//   glMultMatrixf((float*)matrix);
-  //glScalef(2.0, 2.0, 2.0);  // no double rescale
-
-
-//   this->trail->draw();
-
-//   glTranslatef(0,0,-.5);
-//   this->trailL->draw();
-
-//   glTranslatef(0,0,1);
-//   this->trailR->draw();
-
-//   glPopMatrix();
-  //this->debug(0);
 }
 
@@ -477,7 +443,4 @@
   }
 
-  // Playable::tick(time);
-
- // this->test->tick(time);
 
   // Own Tick Setup, as a different fire routine is used on the weapon manager
@@ -528,9 +491,4 @@
   this->oldPos    = this->getAbsCoor();
 
-//FIXME
-//   this->trail->tick(time);
-//   this->trailL->tick(time);
-//   this->trailR->tick(time);
-
   if (!this->isTravelDistanceInit)
   {
@@ -538,18 +496,4 @@
     //this->isTravelDistanceInit = true;
   }
-
-  //orient the spaceship in direction of the mouse
-  /*
-  rotQuat = Quaternion::quatSlerp( this->getAbsDir(), mouseDir, 0.5);//fabsf(time)*shipInertia);
-  if (this->getAbsDir().distance(rotQuat) > 0.00000000000001)
-    this->setAbsDir( rotQuat);
-  //this->setAbsDirSoft(mouseDir,5);
-  */
-  /*
-  this->shiftCoor(move);
-  */
-
-  //   PRINTF(0)("id of %s is: %i\n", this->getName(), this->getOMListNumber());
-
 }
 
Index: /branches/presentation/src/world_entities/world_entity.cc
===================================================================
--- /branches/presentation/src/world_entities/world_entity.cc	(revision 10741)
+++ /branches/presentation/src/world_entities/world_entity.cc	(revision 10742)
@@ -182,7 +182,7 @@
   LoadParam(root, "drawTrack", this, WorldEntity, drawDebugTrack)
       .describe("draws the track for debugging purposes");
-  
+
   LoadParam(root, "forwardDamageToParent", this, WorldEntity, setForwardDamageToParent);
-  
+
   LoadParam(root, "damageable", this, WorldEntity, setDamageable);
 
@@ -190,4 +190,7 @@
   LoadParamXML(root, "Track", this, WorldEntity, addTrack)
   .describe("creates and adds a track to this WorldEntity");
+
+  LoadParam(root, "loadHealth", this, WorldEntity, loadHealth)
+      .describe("set armor/health parameters: current strenght , max strenght");
 }
 