Index: code/branches/campaignHS15/data/levels/Campaign1.oxw
===================================================================
--- code/branches/campaignHS15/data/levels/Campaign1.oxw	(revision 10741)
+++ code/branches/campaignHS15/data/levels/Campaign1.oxw	(revision 10743)
@@ -69,18 +69,20 @@
             <AddQuest questId="quest2" />
             <AddQuest questId="quest2.1" />
-            <AddQuest questId="quest2.2" />
         </complete-effects>
     </GlobalQuest>
 
     <GlobalQuest id="quest2">
-        <QuestDescription title="Prepare to fight the Wave" description="" failMessage="" completeMessage="" />
+        <QuestDescription title="Prepare to fight the Enemy" description="" failMessage="" completeMessage="" />
         <hints>
         </hints>
         <subquests>
             <GlobalQuest id="quest2.1">
-                <QuestDescription title="Get a better Spaceship" description="" failMessage="" completeMessage="" />
+                <QuestDescription title="> Get a better Spaceship" description="" failMessage="" completeMessage="" />
+                <complete-effects>
+                    <AddQuest questId="quest2.2" />
+                </complete-effects>
             </GlobalQuest>
             <GlobalQuest id="quest2.2">
-                <QuestDescription title="Meet your Unit" description="" failMessage="" completeMessage="" />
+                <QuestDescription title="> Meet your Unit" description="" failMessage="" completeMessage="" />
             </GlobalQuest>
         </subquests>
@@ -107,8 +109,8 @@
         <subquests>
             <GlobalQuest id="quest4.1">
-                <QuestDescription title="Get to the Defense Station" description="" failMessage="" completeMessage="" />
+                <QuestDescription title="> Get to the Defense Station" description="" failMessage="" completeMessage="" />
             </GlobalQuest>
             <GlobalQuest id="quest4.2">
-                <QuestDescription title="Find the turret" description="" failMessage="" completeMessage="" />
+                <QuestDescription title="> Find the turret" description="" failMessage="" completeMessage="" />
             </GlobalQuest>
         </subquests>
@@ -135,8 +137,8 @@
         <subquests>
             <GlobalQuest id="quest6.1">
-                <QuestDescription title="Collect the local Pickups" description="" failMessage="" completeMessage="" />
+                <QuestDescription title="> Collect the local Pickups" description="" failMessage="" completeMessage="" />
             </GlobalQuest>
             <GlobalQuest id="quest6.2">
-                <QuestDescription title="Use Portal to the Transporter" description="" failMessage="" completeMessage="" />
+                <QuestDescription title="> Use Portal to the Transporter" description="" failMessage="" completeMessage="" />
             </GlobalQuest>
         </subquests>
@@ -177,5 +179,5 @@
 
     <!-- TODO: find out how to link an event to the COMPLETION of a dock. How is this not possible?? -->
-    <EventMultiTrigger name="dockedA" activations="1" stayactive="true" delay=2>
+    <EventMultiTrigger name="dockedA" activations="1" stayactive="true" delay=3>
         <events>
             <trigger>
@@ -186,5 +188,5 @@
 
     <!-- TODO: fictive unit; to be added later -->
-    <DistanceTrigger name="joinedUnit" position="3500,-1500,0" distance=10 target="SpaceShip" beaconMode="exclude" targetname="NPC" stayactive=true />
+    <DistanceTrigger name="joinedUnit" position="3500,-1500,0" distance=100 target="SpaceShip" beaconMode="exclude" targetname="NPC" stayactive=true />
     <Billboard position="3500,-1500,0" amplitude=1 material="Flares/lensflare" colour="1,0,0.05" />     <!-- For debugging puropses -->
 
@@ -279,4 +281,16 @@
             <execute>
                 <EventListener event="dockedA" />
+            </execute>
+        </events>
+    </QuestEffectBeacon>
+
+    <QuestEffectBeacon times=1>
+        <effects>
+            <CompleteQuest questId="quest2.2" />
+            <CompleteQuest questId="quest2" />
+        </effects>
+        <events>
+            <execute>
+                <EventListener event="joinedUnit" />
             </execute>
         </events>
@@ -566,5 +580,4 @@
     ?>
 
-
     <Planet
         position="5000,0,0"